# Benchmarks

## Benchmarks based on:

* [CraftingInterpreters benchmarks](https://github.com/munificent/craftinginterpreters/tree/master/test/benchmark)
* [Wren Benchmarks](https://github.com/wren-lang/wren/tree/master/test/benchmark)

## Tests
[See the tests ran here](https://github.com/Jason2605/Dictu/tree/develop/tests/benchmarks)

## Results

All benchmarks were ran on an Early 2015 MacBook Pro 2.7GHz Intel Core i5, 8 GB 1867 MHz DDR3 RAM. Each benchmark was ran 5 times and the best time was kept.

| Benchmark            | Time       |
|:---------------------|:-----------|
| Binary Tree          | 0.745782s  |
| Recursive Fibonacci  | 0.222256s  |
| For loop             | 0.085639s  |
| Method Call          | 0.223597s  |
| String Equality      | 0.227614s  |

Last update 20th November 2019.

## Results - Updated

All benchmarks were ran on a 2020 MacBook Pro 2 GHz Quad-Core Intel Core i5, 16 GB 3733 MHz LPDDR4. Each benchmark was ran 10 times and the best time was kept.

| Benchmark            | Time       |
|:---------------------|:-----------|
| Binary Tree          | 0.70105s   |
| Recursive Fibonacci  | 0.198074s  |
| For loop             | 0.069719s  |
| Method Call          | 0.209208s  |
| String Equality      | 0.171062s  |

Last update 18th June 2020.

## Other benchmarks

Benchmarks for string methods [here](string-methods/README.md)
Benchmarks for list methods [here](list-methods/README.md)
Benchmarks for dict methods [here](dict-methods/README.md)